unit RegData;

{
   :    
   :    Winamp-
    :  
           pvabox@mail.ru
}


interface


uses
  Windows, Registry;
  
const
  SubRootKey = 'Software\BCM Dynamic plugin';	{ }

type
  TRegData = record
    Fa, Fb   : array[1..8] of Word;
    Prg      : ShortInt;
    Str, Soft: Boolean;
  end;


//=========   ,    Main =========//

  procedure WriteRegData(Reg: TRegData);
  function 	ReadRegData: TRegData;

//=================================================================//


implementation


//===================     ===================//

procedure WriteRegData(Reg: TRegData);
//    
var
  Link : TRegistry;

begin
  Link:= TRegistry.Create;
  Link.RootKey:= HKEY_CURRENT_USER;
  Link.OpenKey(SubRootKey, true);
  Link.WriteInteger('Fa1',Reg.Fa[1]);
  Link.WriteInteger('Fb1',Reg.Fb[1]);
  Link.WriteInteger('Fa2',Reg.Fa[2]);
  Link.WriteInteger('Fb2',Reg.Fb[2]);
  Link.WriteInteger('Fa3',Reg.Fa[3]);
  Link.WriteInteger('Fb3',Reg.Fb[3]);
  Link.WriteInteger('Fa4',Reg.Fa[4]);
  Link.WriteInteger('Fb4',Reg.Fb[4]);
  Link.WriteInteger('Fa5',Reg.Fa[5]);
  Link.WriteInteger('Fb5',Reg.Fb[5]);
  Link.WriteInteger('Fa6',Reg.Fa[6]);
  Link.WriteInteger('Fb6',Reg.Fb[6]);
  Link.WriteInteger('Fa7',Reg.Fa[7]);
  Link.WriteInteger('Fb7',Reg.Fb[7]);
  Link.WriteInteger('Fa8',Reg.Fa[8]);
  Link.WriteInteger('Fb8',Reg.Fb[8]);
  Link.WriteInteger('Prg',Reg.Prg);
  Link.WriteBool   ('Str',Reg.Str);
  Link.WriteBool   ('Soft',Reg.Soft);
  Link.CloseKey;
  Link.Destroy;
end;


function ReadRegData: TRegData;
//    
var
 Link: TRegistry;
 Tmp : TRegData;
 Flag: Boolean;
begin
  Link:= TRegistry.Create;
  Link.RootKey:= HKEY_CURRENT_USER;
  Flag:= Link.OpenKey(SubRootKey, false);
  if Flag then
    begin
     if Link.ValueExists('Fa1')  then Tmp.Fa[1]:= Link.ReadInteger('Fa1')  else Flag:= false;
     if Link.ValueExists('Fb1')  then Tmp.Fb[1]:= Link.ReadInteger('Fb1')  else Flag:= false;
     if Link.ValueExists('Fa2')  then Tmp.Fa[2]:= Link.ReadInteger('Fa2')  else Flag:= false;
     if Link.ValueExists('Fb2')  then Tmp.Fb[2]:= Link.ReadInteger('Fb2')  else Flag:= false;
     if Link.ValueExists('Fa3')  then Tmp.Fa[3]:= Link.ReadInteger('Fa3')  else Flag:= false;
     if Link.ValueExists('Fb3')  then Tmp.Fb[3]:= Link.ReadInteger('Fb3')  else Flag:= false;
     if Link.ValueExists('Fa4')  then Tmp.Fa[4]:= Link.ReadInteger('Fa4')  else Flag:= false;
     if Link.ValueExists('Fb4')  then Tmp.Fb[4]:= Link.ReadInteger('Fb4')  else Flag:= false;
     if Link.ValueExists('Fa5')  then Tmp.Fa[5]:= Link.ReadInteger('Fa5')  else Flag:= false;
     if Link.ValueExists('Fb5')  then Tmp.Fb[5]:= Link.ReadInteger('Fb5')  else Flag:= false;
     if Link.ValueExists('Fa6')  then Tmp.Fa[6]:= Link.ReadInteger('Fa6')  else Flag:= false;
     if Link.ValueExists('Fb6')  then Tmp.Fb[6]:= Link.ReadInteger('Fb6')  else Flag:= false;
     if Link.ValueExists('Fa7')  then Tmp.Fa[7]:= Link.ReadInteger('Fa7')  else Flag:= false;
     if Link.ValueExists('Fb7')  then Tmp.Fb[7]:= Link.ReadInteger('Fb7')  else Flag:= false;
     if Link.ValueExists('Fa8')  then Tmp.Fa[8]:= Link.ReadInteger('Fa8')  else Flag:= false;
     if Link.ValueExists('Fb8')  then Tmp.Fb[8]:= Link.ReadInteger('Fb8')  else Flag:= false;
     if Link.ValueExists('Prg')  then Tmp.Prg  := Link.ReadInteger('Prg')  else Flag:= false;
     if Link.ValueExists('Str')  then Tmp.Str  := Link.ReadBool   ('Str')  else Flag:= false;
     if Link.ValueExists('Soft') then Tmp.Soft := Link.ReadBool   ('Soft') else Flag:= false;
    end;
  if not Flag then                      {   }
     //    
     with Tmp do
     begin
       //       (1 . = 43 )
       Fa[1]:= 0;       Fb[1]:= 11;
       Fa[2]:= 12;      Fb[2]:= 23;
       Fa[3]:= 24;      Fb[3]:= 35;
       Fa[4]:= 36;      Fb[4]:= 47;
       Fa[5]:= 48;      Fb[5]:= 59;
       Fa[6]:= 60;      Fb[6]:= 71;
       Fa[7]:= 72;      Fb[7]:= 83;
       Fa[8]:= 84;      Fb[8]:= 95;
       //     
       Prg := 0;
       Str := false;
       Soft:= false;
     end;
  Link.CloseKey;
  Link.Destroy;
  Result:= Tmp;
end;

 //============================== END ==============================//

end.

